# Generated by Django 4.1.6 on 2023-04-02 06:17

import datetime
from django.db import migrations, models
import django.utils.timezone
import medux.common.models
from django.utils.translation import gettext_lazy as _


def add_balance_to_all_employees(apps, schema_migration):
    """Create an empty TimeBalanceEntry for every employee."""
    TimeBalanceEntry = apps.get_model("timetracker", "TimeBalanceEntry")
    TimetrackerEmployee = apps.get_model("timetracker", "TimetrackerEmployee")
    for employee in TimetrackerEmployee.objects.all():
        TimeBalanceEntry.objects.create(
            employee=employee, balance=datetime.timedelta(), comment=_("Initial entry")
        )


def remove_all_balances(apps, schema_migration):
    """reverse operation: delete all balances."""
    TimeBalanceEntry = apps.get_model("timetracker", "TimeBalanceEntry")
    TimeBalanceEntry.objects.all().delete()


class Migration(migrations.Migration):
    dependencies = [
        ("timetracker", "0008_monthlytimebilling_payout_month_and_more"),
    ]

    operations = [
        migrations.AlterField(
            model_name="timeentry",
            name="start",
            field=models.DateTimeField(blank=True),
        ),
        migrations.AddField(
            model_name="monthlytimebilling",
            name="payout_time_credit_hours",
            field=models.DecimalField(
                decimal_places=2,
                default=0,
                help_text="All remaining time will get shifted to your time credit balance.",
                max_digits=4,
                verbose_name="Amount of hours to pay out",
            ),
        ),
        migrations.AlterField(
            model_name="timeentry",
            name="start",
            field=models.DateTimeField(blank=True, null=True),
        ),
        migrations.CreateModel(
            name="TimeBalanceEntry",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "created",
                    models.DateTimeField(
                        default=django.utils.timezone.now, editable=False
                    ),
                ),
                (
                    "modified",
                    medux.common.models.AutoDateTimeField(
                        default=django.utils.timezone.now
                    ),
                ),
                ("balance", models.DurationField(blank=True, verbose_name="Balance")),
                (
                    "time_delta",
                    models.DurationField(
                        default=datetime.timedelta(0), verbose_name="Time delta"
                    ),
                ),
                (
                    "employee",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="timetracker.timetrackeremployee",
                    ),
                ),
                (
                    "comment",
                    models.CharField(
                        blank=True, max_length=255, null=True, verbose_name="Comment"
                    ),
                ),
            ],
            options={
                "verbose_name": "Time balance",
                "ordering": ["created"],
            },
        ),
        migrations.RunPython(
            code=add_balance_to_all_employees,
            reverse_code=remove_all_balances,
        ),
        migrations.AddField(
            model_name="timebalanceentry",
            name="time_billing",
            field=models.OneToOneField(
                blank=True,
                null=True,
                on_delete=django.db.models.deletion.PROTECT,
                to="timetracker.monthlytimebilling",
                related_name="time_balance_entry",
            ),
        ),
    ]
